
#include "Arduino.h"
uint16_t icr_0, ocra_0;
uint16_t icr_1, ocra_1;


void setup() {
DDRB |= 1 << PORTB5; // borne 11 configurée en sortie
/* configuration du Timer 1 avec une horloge à 2 MHz (diviseur 8) */
uint16_t diviseur[6] = {0,1,8,64,256,1024};
uint8_t d=2; // diviseur 8
cli(); // désactivation des interruptions
TCCR1A = 0;
TCCR1A |= (1 << COM1A1) ;// clear OC1A on compare match when up-counting, reset OC1A on compare match when down-counting
TCCR1B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR1
uint32_t period = 200; // période en microsecondes
icr_0 = (F_CPU/1000000*period/2/diviseur[d]); // valeur maximale du compteur pour définir la première période
ocra_0 = icr_0/2; // rapport cyclique = 1/2
ICR1 = icr_0;
OCR1A = ocra_0;
TCCR1B |= d; // déclenchement du compteur avec choix du diviseur d'horloge
sei();// activation des interruptions
icr_1 = icr_0*0.9; // seconde période 10% plus petite (180 microsecondes)
ocra_1 = icr_1/2;

}

void loop() {
  // changement périodique de la fréquence
  delay(100); // attente en millisecondes
  ICR1 = icr_0; // première période (200 microsecondes)
  OCR1A = ocra_0;
  delay(100);
  ICR1 = icr_1; // seconde période (180 microsecondes)
  OCR1A = ocra_1;
 
}            
             